%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% プログラム 5.1a: アナログフィルタとディジタルフィルタの比較
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% p.120の図5.10に対応しますが, 本ではプログラムは省略しています。
%---------------------------------------------------------
clear all;clc;
%% パラメータ
Ts =0.005;          % ディジタルフィルタのサンプル周期 
T=0.01;a=1/T;       % 伝達関数の時定数, -aは極に相当する
alpha_d=exp(-a*Ts); % ディジタルフィルタの等価パラメータ

%% シミュレーション
tend=0.1;
open_system('sim_Figure_5_10_comp_digital_filter');
y=sim('sim_Figure_5_10_comp_digital_filter');

%% 描画
% SimulinkモデルのScope'Comp y1&y2'のログでy_outを指定すること。
% Scopeのログの保存形式を「時間付き構造体」に設定する
t=y.y_out.time;
y1=y.y_out.signals(1).values;
y2=y.y_out.signals(2).values;
figure(1);clf(1);
plot(t,y1,'k--',t,y2,'k','LineWidth',1.2);grid on;
xlabel('Time[s]','Fontsize',16);ylabel('DOB filter output [N]','Fontsize',12);
axis([0,tend,0,1.2]);
legend('Output of a/(s+a)', 'Output of (1-\alpha_d)/(z-\alpha_d)','Location','Southeast','Fontsize',12);
set(gca,'Fontname','Times New Roman','FontSize',14);  % 文字の設定
set(gcf,'color','w');   % 枠の周囲を白く変更する

delete('*.slxc');delete('*.asv');

