%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% プログラム 5.3a: DOBを用いたディジタルPI速度制御
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 図5.16と図5.17に対応するプログラム。本の中では省略。
%-----------------------------------------------
clear all;clc;
%% 物理パラメータ
m0=1;d=10; % 質量の公称値[kg],外乱の大きさ[N]
T=0.01;a=1/T;         % ディジタル積分器の周期およびDOBの時定数
zeta=7.5;wn=5;        % PI制御系設計のための減衰定数,応答角周波数
Kp=2*zeta*wn;Ki=wn^2; % PI制御ゲイン
dt=0.005;d_out=0.001; % ランダムノイズの周期と大きさ
alpha_d=exp(-a*T);    % 等価的なディジタル極

%% シミュレーション
tend=5; % 終了時間 
open_system('sim_Figure_5_16_and_5_17_digital_PI_velocity_control_with_DOB');
y=sim('sim_Figure_5_16_and_5_17_digital_PI_velocity_control_with_DOB');

%% 描画
% Scope'f,d&d_hat'のログの変数名をd_outに設定する
% Scope'Vc_ref&Vc'のログの変数名をv_out,'Ac_ref&Ac'のログの変数名をa_outに設定する
% Scopeのログの保存形式を「時間付き構造体」に設定する
t=y.d_out.time;f=y.d_out.signals(1).values;
%
d=y.d_out.signals(2).values(:,1);
d_hat=y.d_out.signals(2).values(:,2);
figure(1);clf(1);plot(t,d,'k--',t,d_hat,'k-','LineWidth',1.2);grid on;
xlabel('Time[s]','Fontsize',16);ylabel('Disturbance[N]','Fontsize',12);
axis([0,tend,-10,20]);
legend('Disturbance', 'Disturbance Est.','Location','Southeast','Fontsize',12);
set(gca,'Fontname','Times New Roman','FontSize',14); % 文字の設定
set(gcf,'color','w');   % 枠の周囲を白く変更するr
%
a_ref=y.a_out.signals(1).values;ac=y.a_out.signals(2).values;
figure(2);clf(2);plot(t,a_ref,'k--',t,ac,'k-','LineWidth',1.2);grid on;
xlabel('Time[s]','Fontsize',16);ylabel('Acceleration[m/s^2]','Fontsize',12);
axis([0,tend,-20,80]);
legend('Acceleration-ref', 'Acceleration','Location','Northeast','Fontsize',12);
set(gca,'Fontname','Times New Roman','FontSize',14); % 文字の設定g
set(gcf,'color','w');   % 枠の周囲を白く変更する
%
vc_ref=y.v_out.signals(1).values;vc=y.v_out.signals(2).values;
figure(3);clf(3);plot(t,vc_ref,'k--',t,vc,'k-','LineWidth',1.2);grid on;
xlabel('Time[s]','Fontsize',16);ylabel('Velocity[m/s]','Fontsize',12);
axis([0,tend,-0.2,1.2]);
legend('Velocity-ref', 'Velocity','Location','Southeast','Fontsize',12);
set(gca,'Fontname','Times New Roman','FontSize',14); % 文字の設定
set(gcf,'color','w');   % 枠の周囲を白く変更する

delete('*.slxc');delete('*.asv');