%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    モデル予測制御のOptimizerの例
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function delta_U=func_mpc_for_cart(u)
global F F1 f Gamma g W w
global Psi Upsilon Theta xn ul delta_U0 Hp Hw Hu Epsilon options
Epsilon=u(1:Hp-Hw+1);u_k_1=u(Hp-Hw+1+1);
x_k=u(Hp-Hw+xn+1:Hp-Hw+xn+2);
FGammaThetaW=[F;Gamma*Theta;W]; % 式(9.14)左辺の記述
F1ufGammagw=[-F1*u_k_1+f;-Gamma*(Psi*x_k+Upsilon*u_k_1)+g;w];% 式(9.14)右辺の記述
%
delta_U=fmincon(@objfun_mpc,delta_U0,FGammaThetaW,F1ufGammagw,[],[],[],[],[],options);
%delta_U=fmincon(@objfun_mpc,delta_U0,[],[]); % 制約条件がない場合は12行目の代わりに用いる

function y=objfun_mpc(delta_U) % 目的関数の記述を行う関数
global H G_temp Epsilon
G=G_temp*Epsilon;
y=delta_U'*H*delta_U-G'*delta_U; % 目的関数